import { ReactElement, ReactNode } from "react";
interface NestedDialogContext {
    stack: readonly string[];
    add: (dialogId: string) => void;
    remove: (dialogId: string) => void;
}
export interface NestedDialogContextProviderProps {
    children: ReactNode;
}
/**
 * This component is used to help with handling nested dialogs by:
 * - preventing all dialogs to be closed when the escape key is pressed
 * - hiding the overlays for dialogs that are not the top-most focus
 *
 * This should be added to the root of your app if you would like to enable this
 * feature.
 */
export declare function NestedDialogContextProvider({ children, }: NestedDialogContextProviderProps): ReactElement;
/**
 * Gets the current nested dialog context. This shouldn't really be used
 * externally and is a private context hook.
 *
 * @internal
 */
export declare function useNestedDialogContext(): NestedDialogContext;
export {};
